define(['dart_sdk', 'packages/test_core/scaffolding', 'packages/w_module/src/event', 'packages/test_api/src/expect/async_matcher', 'packages/matcher/src/core_matchers'], (function load__test__event_test(dart_sdk, packages__test_core__scaffolding, packages__w_module__src__event, packages__test_api__src__expect__async_matcher, packages__matcher__src__core_matchers) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const scaffolding = packages__test_core__scaffolding.scaffolding;
  const event$ = packages__w_module__src__event.src__event;
  const expect = packages__test_api__src__expect__async_matcher.src__expect__expect;
  const expect_async = packages__test_api__src__expect__async_matcher.src__expect__expect_async;
  const throws_matchers = packages__test_api__src__expect__async_matcher.src__expect__throws_matchers;
  const core_matchers = packages__matcher__src__core_matchers.src__core_matchers;
  const equals_matcher = packages__matcher__src__core_matchers.src__equals_matcher;
  var event_test = Object.create(dart.library);
  dart._checkModuleNullSafetyMode(false);
  var T = {
    StringL: () => (T.StringL = dart.constFn(dart.legacy(core.String)))(),
    EventOfStringL: () => (T.EventOfStringL = dart.constFn(event$.Event$(T.StringL())))(),
    VoidToNull: () => (T.VoidToNull = dart.constFn(dart.fnType(core.Null, [])))(),
    StreamL: () => (T.StreamL = dart.constFn(dart.legacy(async.Stream)))(),
    StringLToNull: () => (T.StringLToNull = dart.constFn(dart.fnType(core.Null, [T.StringL()])))(),
    FutureL: () => (T.FutureL = dart.constFn(dart.legacy(async.Future)))(),
    VoidToFutureL: () => (T.VoidToFutureL = dart.constFn(dart.fnType(T.FutureL(), [])))(),
    boolL: () => (T.boolL = dart.constFn(dart.legacy(core.bool)))(),
    StringLToboolL: () => (T.StringLToboolL = dart.constFn(dart.fnType(T.boolL(), [T.StringL()])))(),
    FutureOfNull: () => (T.FutureOfNull = dart.constFn(async.Future$(core.Null)))(),
    FutureLOfNull: () => (T.FutureLOfNull = dart.constFn(dart.legacy(T.FutureOfNull())))(),
    VoidToFutureLOfNull: () => (T.VoidToFutureLOfNull = dart.constFn(dart.fnType(T.FutureLOfNull(), [])))()
  };
  const CT = Object.create({
    _: () => (C, CT)
  });
  event_test.main = function main() {
    scaffolding.group("Event", dart.fn(() => {
      let event = null;
      let key = null;
      scaffolding.setUp(dart.fn(() => {
        key = new event$.DispatchKey.new("test");
        event = new (T.EventOfStringL()).new(key);
      }, T.VoidToNull()));
      scaffolding.test("should inherit from Stream", dart.fn(() => {
        expect.expect(T.StreamL().is(event), core_matchers.isTrue);
      }, T.VoidToNull()));
      scaffolding.test("should provide means to listen to the stream it was created from", dart.fn(() => async.async(dart.dynamic, function*() {
        let completer = async.Completer.new();
        event.listen(dart.fn(payload => {
          expect.expect(payload, equals_matcher.equals("trigger"));
          completer.complete();
        }, T.StringLToNull()));
        event.call("trigger", key);
        return completer.future;
      }), T.VoidToFutureL()));
      scaffolding.test("should support other stream methods", dart.fn(() => async.async(dart.dynamic, function*() {
        let completer = async.Completer.new();
        let filteredStream = event.where(dart.fn(value => value === "water", T.StringLToboolL()));
        filteredStream.listen(expect_async.expectAsync1(core.Null, T.StringL(), dart.fn(payload => {
          expect.expect(payload, equals_matcher.equals("water"));
          completer.complete();
        }, T.StringLToNull())));
        event.call("water", key);
        return completer.future;
      }), T.VoidToFutureL()));
      scaffolding.test("should only allow dispatch with correct key", dart.fn(() => async.async(core.Null, function*() {
        let completer = async.Completer.new();
        event.listen(dart.fn(payload => {
          if (payload === "bad") dart.throw(core.Exception.new("Should not be able to dispatch events without the correct key."));
          if (payload === "good") {
            completer.complete();
          }
        }, T.StringLToNull()));
        let incorrectKey = new event$.DispatchKey.new("incorrect");
        expect.expect(dart.fn(() => {
          event.call("bad", incorrectKey);
        }, T.VoidToNull()), throws_matchers.throwsArgumentError);
        event.call("good", key);
        yield completer.future;
      }), T.VoidToFutureLOfNull()));
      scaffolding.test("should be closable", dart.fn(() => async.async(core.Null, function*() {
        expect.expect(event.isClosed, core_matchers.isFalse);
        yield event.close(key);
        expect.expect(event.isClosed, core_matchers.isTrue);
      }), T.VoidToFutureLOfNull()));
      scaffolding.test("should only allow closing with correct key", dart.fn(() => async.async(core.Null, function*() {
        let incorrectKey = new event$.DispatchKey.new("incorrect");
        expect.expect(event.close(incorrectKey), throws_matchers.throwsArgumentError);
      }), T.VoidToFutureLOfNull()));
      scaffolding.test("should not allow events to be dispatched after being closed", dart.fn(() => async.async(core.Null, function*() {
        yield event.close(key);
        expect.expect(dart.fn(() => {
          event.call("too late", key);
        }, T.VoidToNull()), throws_matchers.throwsStateError);
      }), T.VoidToFutureLOfNull()));
    }, T.VoidToNull()));
  };
  dart.trackLibraries("test/event_test", {
    "org-dartlang-app:///test/event_test.dart": event_test
  }, {
  }, '{"version":3,"sourceRoot":"","sources":["event_test.dart"],"names":[],"mappings":";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;AAyGI,IApFF,kBAAM,SAAS;AACC;AACF;AAKV,MAHF,kBAAM;AACqB,QAAzB,MAAM,2BAAY;AACQ,QAA1B,QAAQ,6BAAc,GAAG;;AAKzB,MAFF,iBAAK,8BAA8B;AACF,QAA/B,cAAa,eAAN,KAAK,GAAY;;AAcxB,MAXF,iBAAK,oEACD;AACQ,wBAAY;AAKpB,QAHF,AAAM,KAAD,QAAQ,QAAC;AACsB,UAAlC,cAAO,OAAO,EAAE,sBAAO;AACH,UAApB,AAAU,SAAD;;AAGU,QAArB,AAAK,KAAA,MAAC,WAAW,GAAG;AACpB,cAAO,AAAU,UAAD;MACjB;AAeC,MAbF,iBAAK,uCAAuC;AAChC,wBAAY;AAIP,6BAAiB,AAAM,KAAD,OAAO,QAAC,SAAU,AAAM,KAAD,KAAI;AAI7D,QAHH,AAAe,cAAD,QAAQ,kDAAa,QAAC;AACF,UAAhC,cAAO,OAAO,EAAE,sBAAO;AACH,UAApB,AAAU,SAAD;;AAGQ,QAAnB,AAAK,KAAA,MAAC,SAAS,GAAG;AAClB,cAAO,AAAU,UAAD;MACjB;AAuBC,MArBF,iBAAK,+CAA+C;AACxC,wBAAY;AASpB,QAPF,AAAM,KAAD,QAAQ,QAAC;AACZ,cAAI,AAAQ,OAAD,KAAI,OACb,AACqE,WAD/D,mBACF;AACN,cAAI,AAAQ,OAAD,KAAI;AACO,YAApB,AAAU,SAAD;;;AAKD,2BAAe,2BAAY;AAIhB,QAFvB,cAAO;AACqB,UAA1B,AAAK,KAAA,MAAC,OAAO,YAAY;4BACxB;AACe,QAAlB,AAAK,KAAA,MAAC,QAAQ,GAAG;AAEK,QAAtB,MAAM,AAAU,SAAD;MAChB;AAMC,MAJF,iBAAK,sBAAsB;AACM,QAA/B,cAAO,AAAM,KAAD,WAAW;AACD,QAAtB,MAAM,AAAM,KAAD,OAAO,GAAG;AACS,QAA9B,cAAO,AAAM,KAAD,WAAW;MACxB;AAOC,MALF,iBAAK,8CAA8C;AAErC,2BAAe,2BAAY;AAEe,QAAtD,cAAO,AAAM,KAAD,OAAO,YAAY,GAAG;MACnC;AAQC,MANF,iBAAK,+DACD;AACoB,QAAtB,MAAM,AAAM,KAAD,OAAO,GAAG;AAGD,QAFpB,cAAO;AACiB,UAAtB,AAAK,KAAA,MAAC,YAAY,GAAG;4BACpB;MACJ;;EAEL","file":"event_test.unsound.ddc.js"}');
  // Exports:
  return {
    test__event_test: event_test
  };
}));

//# sourceMappingURL=event_test.unsound.ddc.js.map
